| Crypto-3.0.3: DES, Blowfish, AES, SHA1, MD5, RSA, X.509 Identity and Attribute Certificates, General ASN.1 Support, Base64, PKCS8, PKCS1v15, Hexdump, Support for Word128, Word192 and Word256 and Beyond, PKCS5 Padding, Various Encryption Modes e.g. Cipher Block Chaining all in one package. | Contents | Index
Codec.ASN1.X509 |
Portability | portable
Stability | experimental
Maintainer | dominic.steinitz@blueyonder.co.uk
Contents
Types Type classes Function types
Description
Definitions to allow the typechecking of an X.509 certificate and functions to extract information from it.
Synopsis
data Certificate = Certificate {
version3 :: Version
serialNumber :: CertificateSerialNumber
signature :: AlgorithmIdentifier
issuer :: Name
validity1 :: Validity
subject :: Name
subjectPublicKeyInfo2 :: SubjectPublicKeyInfo
}
data SignedCertificate = SignedCertificate {
certificate1 :: Certificate
algorithmIdentifier1 :: AlgorithmIdentifier
octetString :: BitString
}
data SubjectPublicKeyInfo = SubjectPublicKeyInfo {
algorithm2 :: AlgorithmIdentifier
subjectPublicKeyInfo1 :: BitString
}
data RSAPublicKey = RSAPublicKey {
modulus1 :: Integer
publicExponent1 :: Integer
}
data AlgorithmIdentifier = AlgorithmIdentifier {
algorithm1 :: Algorithm
parameters1 :: (Maybe Parameters)
}
data AttributeTypeAndValue = AttributeTypeAndValue {
type1 :: OID
value :: DirectoryString
}
data RelativeDistinguishedName = RelativeDistinguishedName (SetOf AttributeTypeAndValue)
data CertificateVersion
time :: TypeDefn
validity :: TypeDefn
attributeTypeAndValue :: TypeDefn
relativeDistinguishedName :: TypeDefn
algorithmIdentifier :: TypeDefn
signedCertificate :: TypeDefn
rsaPublicKey :: TypeDefn
notBefore :: Validity -> Time
notAfter :: Validity -> Time
unName :: Name -> [RelativeDistinguishedName]
unTime :: Time -> VisibleString
unRelativeDistinguishedName :: RelativeDistinguishedName -> SetOf AttributeTypeAndValue
Types
data Certificate
Constructors
Certificate |
version3 :: Version |
serialNumber :: CertificateSerialNumber |
signature :: AlgorithmIdentifier |
issuer :: Name |
validity1 :: Validity |
subject :: Name |
subjectPublicKeyInfo2 :: SubjectPublicKeyInfo |
Instances
Encode Certificate
Eq Certificate
Show Certificate
data SignedCertificate
Constructors
SignedCertificate |
certificate1 :: Certificate |
algorithmIdentifier1 :: AlgorithmIdentifier |
octetString :: BitString |
Instances
Encode SignedCertificate
Eq SignedCertificate
Show SignedCertificate
data SubjectPublicKeyInfo
Constructors
SubjectPublicKeyInfo |
algorithm2 :: AlgorithmIdentifier |
subjectPublicKeyInfo1 :: BitString |
Instances
Encode SubjectPublicKeyInfo
Eq SubjectPublicKeyInfo
Show SubjectPublicKeyInfo
data RSAPublicKey
Constructors
RSAPublicKey |
modulus1 :: Integer |
publicExponent1 :: Integer |
Instances
Encode RSAPublicKey
Eq RSAPublicKey
Show RSAPublicKey
data AlgorithmIdentifier
Constructors
AlgorithmIdentifier |
algorithm1 :: Algorithm |
parameters1 :: (Maybe Parameters) |
Instances
Encode AlgorithmIdentifier
Eq AlgorithmIdentifier
Show AlgorithmIdentifier
data AttributeTypeAndValue
Constructors
AttributeTypeAndValue |
type1 :: OID |
value :: DirectoryString |
Instances
Encode AttributeTypeAndValue
Eq AttributeTypeAndValue
Show AttributeTypeAndValue
data RelativeDistinguishedName
Constructors
RelativeDistinguishedName (SetOf AttributeTypeAndValue) |
Instances
Encode RelativeDistinguishedName
Eq RelativeDistinguishedName
Show RelativeDistinguishedName
data CertificateVersion
Instances
Encode CertificateVersion
Eq CertificateVersion
Show CertificateVersion
Type classes
Function types
time :: TypeDefn
validity :: TypeDefn
attributeTypeAndValue :: TypeDefn
relativeDistinguishedName :: TypeDefn
algorithmIdentifier :: TypeDefn
signedCertificate :: TypeDefn
rsaPublicKey :: TypeDefn
notBefore :: Validity -> Time
notAfter :: Validity -> Time
unName :: Name -> [RelativeDistinguishedName]
unTime :: Time -> VisibleString
unRelativeDistinguishedName :: RelativeDistinguishedName -> SetOf AttributeTypeAndValue
Produced by Haddock version 0.8